// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.ejb.metafacades;

import java.util.Collection;
import java.util.List;
import org.andromda.metafacades.uml.Entity;

/**
 * <p>
 * Represents an entity EJB.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface EJBEntityFacade
    extends Entity
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isEJBEntityFacadeMetaType();

    /**
     * <p>
     * Find all associations that define relations to other entities.
     * </p>
     * <p>
     * This method returns the source association ends for all
     * associations that define
     * </p>
     * <p>
     * a container managed relation.  The returned collection includes
     * both
     * </p>
     * <p>
     * direct relations and inherited relations. A direct relation is
     * an association with some other class matching the following
     * criteria: 1) The class at the other side of the association is
     * stereotyped <<Entity>> 2) The association is navigable from to
     * the other side.
     * </p>
     * <p>
     * An inherited relation is an association from an abstract super
     * type matching the following criteria: 1) The inheritance path to
     * this abstract super type, including this super type itself,
     * consists only of abstract classes with stereotype <<Entity>> 2) 
     * The class at the other side of the association is stereotyped
     * <<Entity>>. 3) The association is navigable from this abstract
     * super type to the other side.
     * </p>
     * <p>
     * Relations must match the following integrity constraint:
     * </p>
     * <p>
     * - The <<Entity>> at the target end is not abstract.
     * </p>
     * <p>
     * The integrity constraint is necessary because the target of a
     * container managed relation in the EJB framework must be a
     * concrete entity bean; there is no such thing as an
     * </p>
     * <p>
     * "abstract entity bean" in the EJB specification. It is possible,
     * however, to generate and compile code for this case, an error
     * will only show up at deploy time. In order to catch
     * </p>
     * <p>
     * this kind of error at the earliest possible stage, this method
     * checks the integrity constraint and throws an exception if it is
     * violated.
     * </p>
     * @return Collection
     */
    public Collection getAllEntityRelations();

    /**
     * <p>
     * All instanceAttributes for this entity. The list includes the
     * instanceAttributes that are inherited from super classes. The
     * list contains the inherited instanceAttributes first, followed
     * by the instanceAttributes defined in this class.
     * </p>
     * @return List
     */
    public List getAllInstanceAttributes();

    /**
     * <p>
     * Gets all constants for this entity. Constants are defined as
     * static read-only attributes which do NOT have the <<EnvEntry>>
     * stereotype.   If 'follow' is true, then the inheritance hierachy
     * will be followed and we'll retrieve all constants from any super
     * types as well.
     * </p>
     * @param follow boolean
     * @return Collection
     */
    public Collection getConstants(boolean follow);

    /**
     * <p>
     * Gets create methods for the entity.  If 'follow'l is set to
     * true, create methods from any super types will also be retrieved
     * by following up the inheritance chain.
     * </p>
     * @param follow boolean
     * @return Collection
     */
    public Collection getCreateMethods(boolean follow);

    /**
     * 
     * @return Collection
     */
    public Collection getEntityRelations();

    /**
     * <p>
     * Gets all env-entries for the specified entity EJB. Env-entries
     * are stored as static attributes on the entity and stereotyped as
     * <<EnvEntry>>.  If 'follow' is true, then the inheritance
     * hierachy will be followed and we'll retrieve all env-entries
     * from any super types as well.
     * </p>
     * @param follow boolean
     * @return Collection
     */
    public Collection getEnvironmentEntries(boolean follow);

    /**
     * <p>
     * A String representing the name of a home interface for this
     * entity EJB.
     * </p>
     * @return String
     */
    public String getHomeInterfaceName();

    /**
     * <p>
     * All inherited instanceAttributes this class.  The
     * instanceAttributes are grouped by the class that defines the
     * instanceAttributes, with instanceAttributes from the most
     * removed super class first.
     * </p>
     * @return List
     */
    public List getInheritedInstanceAttributes();

    /**
     * 
     * @return String
     */
    public String getJndiName();

    /**
     * <p>
     * Gets select methods for the entity, if all is set to 'true' then
     * ALL select methods will be retrieved (including those inherited
     * from any superclasses).
     * </p>
     * @param follow boolean
     * @return Collection
     */
    public Collection getSelectMethods(boolean follow);

    /**
     * 
     * @return String
     */
    public String getSqlType();

    /**
     * <p>
     * Gets the transaction type for this entity (i.e. REQUIRED, etc)
     * </p>
     * @return String
     */
    public String getTransactionType();

    /**
     * 
     * @return Collection
     */
    public Collection getValueDependencies();

    /**
     * <p>
     * A string indicating whether the Bean is a local or remotely
     * accessable bean.
     * </p>
     * @return String
     */
    public String getViewType();

    /**
     * 
     * @param att String
     * @return boolean
     */
    public boolean isAttributePresent(String att);

    /**
     * 
     * @param id String
     * @return boolean
     */
    public boolean isIdentifierPresent(String id);

    /**
     * 
     * @param op String
     * @return boolean
     */
    public boolean isOperationPresent(String op);

    /**
     * <p>
     * Whether or not to allow a synthetic (auto generated) create
     * method.
     * </p>
     * @return boolean
     */
    public boolean isSyntheticCreateMethodAllowed();
}