// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.cartridges.ejb.metafacades;

import java.util.Collection;
import java.util.List;
import org.andromda.metafacades.uml.Service;

/**
 * <p>
 * Represents a Session EJB.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface EJBSessionFacade
    extends Service
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isEJBSessionFacadeMetaType();

    /**
     * <p>
     * All instanceAttributes for this session EJB. The list includes
     * the instanceAttributes that are inherited from super classes.
     * The list contains the inherited instanceAttributes first,
     * followed by the instanceAttributes defined in this class.
     * </p>
     * @return List
     */
    public List getAllInstanceAttributes();

    /**
     * <p>
     * All "business" operations for this Session EJB.  These are any
     * operations that are NOT
     * </p>
     * <p>
     * identified as create methods.
     * </p>
     * @return Collection
     */
    public Collection getBusinessOperations();

    /**
     * <p>
     * Gets all constants for this session EJB. Constants are defined
     * as static read-only attributes which do NOT have the
     * <<EnvEntry>> stereotype.  If 'follow' is true, then the
     * inheritance hierachy will be followed and we'll retrieve all
     * constants from any super types as well.
     * </p>
     * @param follow boolean
     * @return Collection
     */
    public Collection getConstants(boolean follow);

    /**
     * <p>
     * Gets create methods for this session EJB.  If 'follow' is set to
     * true, it will follow the inheritance hierarchy and retrieve
     * those defined on any super types.
     * </p>
     * @param follow boolean
     * @return Collection
     */
    public Collection getCreateMethods(boolean follow);

    /**
     * <p>
     * Gets all env-entries for the specified session EJB. Env-entries
     * are stored as static attributes on the entity and stereotyped as
     * <<EnvEntry>>.  If 'follow' is true, then the inheritance
     * hierachy will be followed and we'll retrieve all env-entries
     * from any super types as well.
     * </p>
     * @param follow boolean
     * @return Collection
     */
    public Collection getEnvironmentEntries(boolean follow);

    /**
     * <p>
     * A String representing the name of a home interface for this
     * entity EJB.
     * </p>
     * @return String
     */
    public String getHomeInterfaceName();

    /**
     * <p>
     * Alll inherited instanceAttributes this session EJB.  The
     * instanceAttributes are grouped by the class that defines the
     * instanceAttributes, with instanceAttributes from the most
     * removed super class first.
     * </p>
     * @return List
     */
    public List getInheritedInstanceAttributes();

    /**
     * <p>
     * The JNDI name to which this session EJB is bound.
     * </p>
     * @return String
     */
    public String getJndiName();

    /**
     * <p>
     * Gets the transaction type for this service (i.e. REQUIRED, etc)
     * </p>
     * @return String
     */
    public String getTransactionType();

    /**
     * <p>
     * The name of the type of this Session EJB.
     * </p>
     * @return String
     */
    public String getType();

    /**
     * <p>
     * A string indicating whether the Bean is a local or remotely
     * accessable bean.
     * </p>
     * @return String
     */
    public String getViewType();

    /**
     * <p>
     * True/false depending on whether or not this Session EJB is
     * stateful or not.
     * </p>
     * @return boolean
     */
    public boolean isStateful();

    /**
     * <p>
     * True/false depending on whether or not this Session EJB is
     * stateless or not.
     * </p>
     * @return boolean
     */
    public boolean isStateless();

    /**
     * <p>
     * Whether or not to allow a synthetic (auto generated) create
     * method.
     * </p>
     * @return boolean
     */
    public boolean isSyntheticCreateMethodAllowed();
}